/* 
 * Naive XML parser for RSS v9.x
 * Not yet fully conformant.
 * 2002-2003 HShivanan
 *
 * For licensing terms, see the file COPYING in this directory
 * For contact information, see the file AUTHORS in this directory
 *
 */

#include <stdio.h>
#include <string.h>
#include "stuff.h"
#include "xmlscan.h"
#include "item.h"
#include "fn.h"
#define copy_token(x)   x=(char *)fn_malloc(scanner->count+1);\
			memcpy(x,scanner->token,scanner->count);\
			x[scanner->count]=0
//#define copy_token(x) {x=(char *)fn_malloc(strlen(scanner->token)+1);memcpy(x,scanner->token,strlen(scanner->token));x[strlen(scanner->token)]=0;}while(0)
/* *channel must be preallocated*/
void parse_channel(XML_SCANNER *scanner,char *channel,int channel_length)
{
	int l;
	ASSERT(channel_length>0);
	ASSERT(scanner->tokenid==CHANNEL_O);
	xml_nexttoken(scanner);
	
	while(scanner->tokenid!=_NULL)
	{
		switch(scanner->tokenid)
		{
			case CHANNEL_C:return;
			case TITLE_O:  		xml_nexttoken(scanner);
								l=scanner->count;
								if (l>channel_length)l=channel_length;
								memcpy(channel,scanner->token,l);
								channel[l]=0;
								xml_nexttoken(scanner);
								break;
			default:xml_nexttoken(scanner);
		}
	}
}
void parse_item(XML_SCANNER *scanner,ITEM_LIST **il,char *channel)
{
	char *item=NULL,*link=NULL,*description=NULL;
	xml_nexttoken(scanner);
	
	while(scanner->tokenid!=_NULL)
	{
		switch(scanner->tokenid)
		{
			case ITEM_C:
						if (!add_item(il,channel,item,link,description))
							print("unable to add item\n");
						return;
			case TITLE_O:		xml_nexttoken(scanner);
								copy_token(item);
								xml_nexttoken(scanner);
								break;
			case DESCRIPTION_O:	xml_nexttoken(scanner);
// 								if (scanner->tokenid==DESCRIPTION_C)
// 									description==NULL;
// 								else
// 								{
									copy_token(description);
									xml_nexttoken(scanner);
// 								}
								break;
			case LINK_O:		xml_nexttoken(scanner);
								copy_token(link);
								xml_nexttoken(scanner);
								break;
			default:xml_nexttoken(scanner);
		}
	}
}
int verify_xml(XML_SCANNER *scanner)
{
	xml_nexttoken(scanner);
	if (scanner->tokenid==XML)
	{
		xml_nexttoken(scanner);
		return 1;
	}
	return 0;
// 	return (scanner->tokenid==XML);
}
int verify_file_type(TOKENTYPE t)
{
	return ( (t==RSS_O)||(t==RDF_O));
}
void skip_chaff(XML_SCANNER *scanner)
{
// 	xml_nexttoken(scanner);
	while ( ((scanner->tokenid==DOCTYPE)||(scanner->tokenid==COMMENT))
			&& (scanner->tokenid!=_NULL))
		xml_nexttoken(scanner);
}
void parse_newsfeed(ITEM_LIST **il,char *buffer,char *url,char *description)
{
	int i;
	XML_SCANNER scan;
	XML_SCANNER *scanner;
	TOKENTYPE file_type;
	char *channel;
	scanner=&scan;
	scanner->code=buffer;
	scanner->token=(char *)fn_malloc(10);
	scanner->capacity=10;
	channel=(char *)fn_malloc(CHANNEL_LENGTH+1);
	ASSERT(channel!=NULL);
	i=strlen(url);
	if (i>CHANNEL_LENGTH)
	{
		i=CHANNEL_LENGTH;
	}
	if (description!=NULL)
		memcpy(channel,description,i);
	else
		memcpy(channel,url,i);
	channel[i]=0;
	if (!verify_xml(scanner))
	{
		verbose("Unable to find xml token\n",url);
 		return;
	}
 	skip_chaff(scanner);
	file_type=scanner->tokenid;
	if (!verify_file_type(file_type))
	{
		print("%s does not represent a supported feed type\n",url);
		return;
	}
	while (scanner->tokenid!=_NULL)
	{
		xml_nexttoken(scanner);
		switch(scanner->tokenid)
		{
			case CHANNEL_O:if (file_type==RDF_O && description==NULL)
							   parse_channel(scanner,channel,CHANNEL_LENGTH);break;
			case ITEM_O:   parse_item(scanner,il,channel);break;//nasty bug here
			default:
		}//*/
	}
	fn_free(scanner->token);
	fn_free(channel);
}
